package org.intranet.games.minesweeper.swing;

import org.intranet.games.minesweeper.PlayingField;

/** 
 * @author Chris Dailey
 */
class GameStatusButton
  extends javax.swing.JButton
{
  private PlayingField.Status status;
  public GameStatusButton()
  {
    super();
    java.awt.Dimension size = new java.awt.Dimension(30, 30);
    setPreferredSize(size);
    setMinimumSize(size);
    setMaximumSize(size);
    setStatus(PlayingField.Status.initted);
  }
  public void setStatus(PlayingField.Status stat)
  {
    status = stat;
    repaint();
  }
  public void paintComponent(java.awt.Graphics g)
  {
    super.paintComponent(g);
    int xoffset = 3;
    int yoffset = 3;
    int w = getWidth();
    int h = getHeight();
    g.setColor(java.awt.Color.yellow);
    g.fillArc(xoffset, yoffset, getWidth() - (2 * xoffset) - 1, getHeight() - (2 * yoffset) - 1, 0, 360);
    g.setColor(java.awt.Color.black);
    g.drawArc(xoffset, yoffset, getWidth() - (2 * xoffset) - 1, getHeight() - (2 * yoffset) - 1, 0, 360);
    int eyeSize = 3;
    if (status == PlayingField.Status.won)
    {
      g.drawArc((int)(w * 0.25), (int)(h * 0.25), w / 2, h / 2, 225, 90);
      eyeSize = 4;
    }
    g.fillOval((int)(w * 0.4) - eyeSize / 2 - 1, (int)(h * 0.3), eyeSize, eyeSize); // r eye
    g.fillOval((int)(w * 0.6) - eyeSize / 2, (int)(h * 0.3), eyeSize, eyeSize); // l eye

    if (status == PlayingField.Status.initted || status == PlayingField.Status.inprogress)
      g.drawLine((int)(w * 0.35), (int)(h * 0.65), (int)(w * 0.65) - 1, (int)(h * 0.65));
    if (status == PlayingField.Status.lost)
      g.drawArc((int)(w * 0.25), (int)(h * 0.6), w / 2, h / 2, 45, 90);
    if (status == PlayingField.Status.won)
      g.drawArc((int)(w * 0.25), (int)(h * 0.25), w / 2, h / 2, 225, 90);
  }
}