package org.intranet.games.minesweeper.swing;
// Copyright 2002 Chris Dailey
// License terms at http://www.gnu.org/licenses/lgpl.html

/** 
 *
 * @author Chris
 */
public class LEDDigit
  extends javax.swing.JComponent
{
  private LED led = new LED();
  private int value;
  private static final boolean[][] lightList =
  {
    {true, true, true, false,true, true, true, false}, // 0
    {false,false,true, false,false,true, false,false}, // 1
    {true, false,true, true, true, false,true, false}, // 2
    {true, false,true, true, false,true, true, false}, // 3
    {false,true, true, true, false,true, false,false}, // 4
    {true, true, false,true, false,true, true, false}, // 5
    {false,true, false,true, true, true, true, false}, // 6
    {true, false,true, false,false,true, false,false}, // 7
    {true, true, true, true, true, true, true, false}, // 8
    {true, true, true, true, false,true, false,false}, // 9
    {false,false,false,false,false,false,false,false}, // 10 is blank
    {false,false,false,true, false,false,false,false}, // 11 is negative
  };
  public static final int BLANK = 10;
  public static final int NEGATIVE = 11;
  public LEDDigit()
  {
    this(BLANK);
  }
  public LEDDigit(int initialValue)
  {
    // TODO : initValue must be 0-11
    super();
    setLayout(new java.awt.BorderLayout());
    add(led, java.awt.BorderLayout.CENTER);
    setValue(initialValue);
  }

  // TODO : newValue must be 0-11
  public void setValue(int newValue)
  {
    if (value == newValue)
      return;
    value = newValue;
    led.setLights(lightList[newValue]);
  }
  public int getValue() { return value; }
}