package org.intranet.games.minesweeper.swing;
// Copyright 2002 Chris Dailey
// License terms at http://www.gnu.org/licenses/lgpl.html

import org.intranet.games.minesweeper.*;
import javax.swing.JFrame;
import javax.swing.JDialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/** 
 * @author Chris Dailey
 */
public class MineSweeper
{
  private PlayingField pf = new PlayingField();
  private JFrame f = new JFrame("Minesweeper");
  private JDialog aboutDialog = new AboutDialog(f);

  public MineSweeper()
  {
    f.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent we) {
        System.exit(0);
      }
    });
    f.getContentPane().add(new PlayingFieldView(pf));
    f.setJMenuBar(createMenu());
    f.pack();
    f.setVisible(true);
  }

  private javax.swing.JMenuBar createMenu()
  {
    javax.swing.JMenuBar menuBar = new javax.swing.JMenuBar();
    javax.swing.JMenu menuFile = new javax.swing.JMenu("File");
    menuBar.add(menuFile);
    javax.swing.JMenu menuHelp = new javax.swing.JMenu("Help");
    menuBar.add(menuHelp);

    javax.swing.ButtonGroup group = new javax.swing.ButtonGroup();

    javax.swing.JRadioButtonMenuItem menuFileBeginner = new javax.swing.JRadioButtonMenuItem("Beginner");
    menuFileBeginner.setSelected(true);
    group.add(menuFileBeginner);
    menuFile.add(menuFileBeginner);
    menuFileBeginner.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent ae) {
        pf.changeConfiguration(8, 8, 10);
        f.pack();
      }
    });

    javax.swing.JRadioButtonMenuItem menuFileIntermediate = new javax.swing.JRadioButtonMenuItem("Intermediate");
    group.add(menuFileIntermediate);
    menuFile.add(menuFileIntermediate);
    menuFileIntermediate.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent ae) {
        pf.changeConfiguration(16, 16, 40);
        f.pack();
      }
    });

    javax.swing.JRadioButtonMenuItem menuFileAdvanced = new javax.swing.JRadioButtonMenuItem("Advanced");
    group.add(menuFileAdvanced);
    menuFile.add(menuFileAdvanced);
    menuFileAdvanced.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent ae) {
        pf.changeConfiguration(30, 16, 99);
        f.pack();
      }
    });

    javax.swing.JSeparator menuFileSeparator1 = new javax.swing.JSeparator();
    menuFile.add(menuFileSeparator1);

    javax.swing.JMenuItem menuFileExit = new javax.swing.JMenuItem("Exit");
    menuFileExit.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent ae) {
        System.exit(0);
      }
    });
    menuFile.add(menuFileExit);

    javax.swing.JMenuItem menuHelpAbout = new javax.swing.JMenuItem("About ...");
    menuHelpAbout.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent ae) {
        aboutDialog.setLocation(
          f.getX() + f.getWidth()/2 - aboutDialog.getWidth()/2,
          f.getY() + f.getHeight()/2 - aboutDialog.getHeight()/2);
        aboutDialog.setVisible(true);
      }
    });
    menuHelp.add(menuHelpAbout);

    return menuBar;
  }

  public static void main(String[] args)
  {
    new MineSweeper();
  }
}