package org.intranet.games.minesweeper.swing;
// Copyright 2002 Chris Dailey
// License terms at http://www.gnu.org/licenses/lgpl.html

/** 
 *
 * @author Chris Dailey
 */
public class NumberDisplay
  extends javax.swing.JComponent
{
  private int value = 0;
  LEDDigit[] digits;
  public NumberDisplay(int numDigits)
  {
    super();
    java.awt.FlowLayout flowLayout = new java.awt.FlowLayout();
    flowLayout.setHgap(0);
    setLayout(flowLayout);
    digits = new LEDDigit[numDigits];
    for (int i = 0; i < numDigits; i++)
    {
      digits[i] = new LEDDigit();
      add(digits[i]);
    }
    setValue(Integer.MAX_VALUE);
  }
  private static java.text.NumberFormat negative = (java.text.NumberFormat)java.text.NumberFormat.getInstance().clone();
  private static java.text.NumberFormat positive = (java.text.NumberFormat)java.text.NumberFormat.getInstance().clone();
  static
  {
    negative.setMinimumIntegerDigits(2);
    positive.setMinimumIntegerDigits(3);
  }
  // blank = Integer.MAX_VALUE or Integer.MIN_VALUE
  public void setValue(int newValue)
  {
    value = newValue;
    if (value == Integer.MAX_VALUE || value == Integer.MIN_VALUE)
    {
      for (int i = 0; i < digits.length; i++)
        digits[i].setValue(LEDDigit.BLANK);
      return;
    }
    String text = (newValue >= 0) ?
      positive.format(value) : negative.format(value);
    for (int i = 0; i < digits.length; i++)
    {
      char character = text.charAt(i);
      if (character == '-')
        digits[i].setValue(LEDDigit.NEGATIVE);
      else if (Character.isDigit(character))
      {
        digits[i].setValue(Character.digit(character, 10));
      }
      else
        digits[i].setValue(LEDDigit.BLANK);
    }
  }
  public int getValue() { return value; }
  public void setPower(boolean onOff) { }
}