package org.intranet.games.minesweeper.swing;
// Copyright 2002 Chris Dailey
// License terms at http://www.gnu.org/licenses/lgpl.html

import org.intranet.games.minesweeper.PlayingField;
import org.intranet.games.minesweeper.Square;
import org.intranet.graphics.zing.Grid;

/**
*
* @author Chris Dailey
*/
public class PlayingFieldModel
  implements Grid.GridModel,
             PlayingField.PlayingFieldListener
{
  PlayingField playingField;
  PlayingFieldModel(PlayingField aPlayingField)
  {
    playingField = aPlayingField;
    playingField.addPlayingFieldListener(this);
  }
  java.util.List mListeners = new java.util.ArrayList();
  public int getColumnCount()
  { return playingField.getWidth(); }
  public int getRowCount()
  { return playingField.getHeight(); }
  public Object getValueAt(int row, int col)
  { return playingField.getSquare(col, row); }
  public void removeGridModelListener(Grid.GridModelListener l)
  { mListeners.remove(l); }
  public void addGridModelListener(Grid.GridModelListener l)
  { mListeners.add(l); }
  public void playingFieldConfigurationChanged(PlayingField.PlayingFieldEvent pfe)
  { playingFieldSquareChanged(null); }
  public void playingFieldCounterUpdated(int value)
  { }
  public void playingFieldSquareChanged(Square s)
  {
    java.util.Iterator i = mListeners.iterator();
    while (i.hasNext()) {
      Grid.GridModelListener l = (Grid.GridModelListener)i.next();

      if (s == null)
        l.gridModelConfigurationChanged();
      else
        l.gridModelCellChanged(s.getY(), s.getX());
    }
  }
  public void playingFieldStatusChanged(PlayingField.Status s)
  { }
  public void timerValueChanged(int s)
  { }
}